part of nueli.core.bucket;

Gallery get gallery => Gallery.configure();

class Gallery extends Bucket<Picture> {
  Gallery.configure() : super.configure();
  @override
  Symbol get _iD => #gallery;
}

class Picture {
  final IconData? data;
  final String? src;
  final String? path;

  @protected
  Picture.library(this.data)
      : src = null,
        path = null;

  @protected
  Picture.network(this.src)
      : data = null,
        path = null;

  @protected
  Picture.asset(this.path)
      : data = null,
        src = null;
}

extension Library_Gallery on Gallery {
  static void configure(
    Picture flash,
    Picture flashOff,
    Picture favorite,
    Picture favoriteFill,
    Picture check,
    Picture checkFill,
  ) {
    (gallery * #flash)[Picture.library(Icons.flash_on)] = flash;
    (gallery * #flashOff)[Picture.library(Icons.flash_off)] = flashOff;
    (gallery * #favorite)[Picture.library(CupertinoIcons.suit_heart)] = favorite;
    (gallery * #favoriteFill)[Picture.library(CupertinoIcons.suit_heart_fill)] = favoriteFill;
    (gallery * #check)[Picture.library(CupertinoIcons.checkmark_square)] = flash;
    (gallery * #checkFill)[Picture.library(CupertinoIcons.checkmark_square_fill)] = flash;
  }

  Picture get flash => (gallery * #flash)[Picture.library(Icons.flash_on)];
  Picture get flashOff => (gallery * #flash_off)[Picture.library(Icons.flash_off)];
  Picture get favorite => (gallery * #favorite)[Picture.library(CupertinoIcons.suit_heart)];
  Picture get favoriteFill => (gallery * #favoriteFill)[Picture.library(CupertinoIcons.suit_heart_fill)];
  Picture get check => (gallery * #check)[Picture.library(CupertinoIcons.app)];
  Picture get checkFill => (gallery * #checkFill)[Picture.library(CupertinoIcons.checkmark_square_fill)];
}
